@*******************************
@* GBA Graphics Library        *
@*  by Jeff Frohwein           *
@* http://www.devrs.com        *
@*******************************
@ v1.0222 - Original release

@ This version is relatively slow. Use line2.s or line3.s instead.

@ Draw pixel in GBA graphics modes 3 or 5 in ARM asm
@ Entry: x1 = pixel x1 coordinate
@        y1 = pixel y1 coordinate
@        x2 = pixel x2 coordinate
@        y2 = pixel y2 coordinate
@     color = pixel color
@ (void) gfxLine1 (u8 x1, u8 y1, u8 x2, u8 y2, u16 color);

        .ARM
        .ALIGN
        .GLOBL  gfxLine1

@ r0 = x1
@ r1 = y1
@ r2 = x2 /
@ r3 = y2 /
@ r4 = temp / de
@ r5 = deldx
@ r6 = deldy
@ r7 = dy /
@ r8 = total pixel count
@ r9 = delsx
@ r10 = delsy
@ r11 = delse
@ r12 = delde

gfxLine1:
        sub     sp,sp,#4         @ protect the stack so color doesn't
                                 @  doesn't get overwritten.
        stmfd   r13!,{r0-r12,r14}
        mov     r5,#1            @ deldx
        mov     r6,#1            @ deldy

        subs    r7,r3,r1         @ r7 = y2 - y1
        rsbmi   r6,r6,#0         @ di=-1 if r7 is negative
        rsbmi   r7,r7,#0         @ make r7 positive
        mov     r10,r6           @ delsy

        subs    r8,r2,r0         @ r8 = x2 - x1
        rsbmi   r5,r5,#0         @ di=-1 if r8 is negative
        rsbmi   r8,r8,#0         @ make r8 positive
        mov     r9,r5            @ delsx

        subs    r4,r8,r7
        movmi   r4,r8,lsl #0     @ exchange r7 & r8 if r8 is smaller
        movmi   r8,r7,lsl #0
        movmi   r7,r4,lsl #0
        movmi   r9,#0
        movpl   r10,#0

        mov     r11,r7,lsl #1    @ delse = delp * 2
        sub     r4,r11,r8        @ de = delse - dels
        sub     r12,r4,r8        @ delde = delse - (dels * 2)

@ adjust count

        add     r8,r8,#1         @ r8 = total pixel count
        ldr     r2,[r13,#60]     @ Get the color off stack
_DLine5:

@ Plot pixel r0,r1 with color r2
        mov     r3,#480
        mul     r7,r3,r1
        add     r7,r7,r0,lsl #1
        add     r3,r7,#0x6000000
        strh    r2,[r3]

        movs    r4,r4
        bpl     _DLine7

@ straight move
        add     r0,r0,r9
        add     r1,r1,r10
        add     r4,r4,r11

        subs    r8,r8,#1
        bne     _DLine5

        ldmfd   r13!,{r0-r12,r14}
        add     sp,sp,#4
        bx      r14

_DLine7:
@ diagonal move
        add     r0,r0,r5
        add     r1,r1,r6
        add     r4,r4,r12

        subs    r8,r8,#1
        bne     _DLine5

        ldmfd   r13!,{r0-r12,r14}
        add     sp,sp,#4
        bx      r14

