@*******************************
@* GBA Graphics Library        *
@*  by Jeff Frohwein           *
@* http://www.devrs.com        *
@*******************************
@ v1.0222 - Original release

@ OBSOLETE - Use line4.s

@ Straight lines - 3 instructions/pixel
@ Angular lines  - 7 instructions/pixel

@ Draw a solid line in GBA graphics modes 3/5 in ARM asm
@ Entry: x1 = pixel x1 coordinate
@        y1 = pixel y1 coordinate
@        x2 = pixel x2 coordinate
@        y2 = pixel y2 coordinate
@     color = pixel color
@      addr = screen base address
@ (void) gfxLine2 (u8 x1, u8 y1, u8 x2, u8 y2, u16 color, u32 addr);

        .ARM
        .ALIGN
        .GLOBL  gfxLine2

@ r0 = x1
@ r1 = y1
@ r2 = x2 / pixel color
@ r3 = y2 / pixel address
@ r4 = temp / de
@ r5 = deldx
@ r6 = deldy
@ r7 = dy /
@ r8 = total pixel count
@ r9 = delsx
@ r10 = delsy
@ r11 = delse
@ r12 = delde

gfxLine2:
        sub     sp,sp,#8         @ protect the stack so color doesn't
                                 @  doesn't get overwritten.

        cmp     r1,r3            @ Is the line horizontal ?
        beq     2f               @ yes
        cmp     r0,r2            @ Is the line vertical ?
        beq     4f               @ yes

        stmfd   r13!,{r0-r12,r14}
        mov     r5,#2            @ deldx
        mov     r6,#480          @ deldy

        subs    r7,r3,r1         @ r7 = y2 - y1
        rsbmi   r6,r6,#0         @ di=-1 if r7 is negative
        rsbmi   r7,r7,#0         @ make r7 positive
        mov     r10,r6           @ delsy

        subs    r8,r2,r0         @ r8 = x2 - x1
        rsbmi   r5,r5,#0         @ di=-1 if r8 is negative
        rsbmi   r8,r8,#0         @ make r8 positive
        mov     r9,r5            @ delsx

        subs    r4,r8,r7
        movmi   r4,r8,lsl #0     @ exchange r7 & r8 if r8 is smaller
        movmi   r8,r7,lsl #0
        movmi   r7,r4,lsl #0
        movmi   r9,#0
        movpl   r10,#0

        mov     r11,r7,lsl #1    @ delse = delp * 2
        sub     r4,r11,r8        @ de = delse - dels
        sub     r12,r4,r8        @ delde = delse - (dels * 2)

        add     r8,r8,#1         @ r8 = total pixel count
        ldr     r2,[r13,#64]     @ r2 = color off stack

        add     r9,r9,r10        @ r9 = straight pixel move
        add     r5,r5,r6         @ r5 = diagonal pizel move

        ldr     r6,[r13,#68]     @ Get the screen base address

@ calculate pixel address

        mov     r3,#480
        mul     r7,r3,r1
        add     r7,r7,r0,lsl #1
        add     r3,r7,r6         @ r3 = start pixel addr

0:
@ Plot pixel r0,r1 with color r2
        strh    r2,[r3]

        movs    r4,r4
        bpl     1f

@ straight move
        add     r3,r3,r9
        add     r4,r4,r11

        subs    r8,r8,#1
        bne     0b

        ldmfd   r13!,{r0-r12,r14}
        add     sp,sp,#8
        bx      r14

1:
@ diagonal move
        add     r3,r3,r5
        add     r4,r4,r12

        subs    r8,r8,#1
        bne     0b

        ldmfd   r13!,{r0-r12,r14}
        add     sp,sp,#8
        bx      r14

@ ******** Draw a horizontal line ********

2:
        stmfd   r13!,{r2-r8,r14}
        mov     r5,r0
        mov     r6,r1

        subs    r4,r2,r0
        rsbmi   r4,r4,#0         @ make r4 positive
        movmi   r5,r2
        movmi   r6,r3            @ make r5,r6 left most point

        add     r4,r4,#1         @ r4 = pixel count

        ldr     r2,[r13,#40]     @ Get the color off stack
        ldr     r8,[r13,#44]     @ Get the screen base address

@ calculate pixel address

        mov     r3,#480
        mul     r7,r3,r6
        add     r7,r7,r5,lsl #1
        add     r3,r7,r8

        mov     r5,#2
3:

@ Plot pixel [r3] with color r2
        strh    r2,[r3],r5
        subs    r4,r4,#1
        bne     3b

        ldmfd   r13!,{r2-r8,r14}
        add     sp,sp,#8
        bx      r14

@ ******** Draw a vertical line ********

4:
        stmfd   r13!,{r2-r8,r14}
        mov     r5,r0
        mov     r6,r1

        subs    r4,r3,r1
        rsbmi   r4,r4,#0         @ make r4 positive
        movmi   r5,r2
        movmi   r6,r3            @ make r5,r6 top most point

        add     r4,r4,#1         @ r4 = pixel count

        ldr     r2,[r13,#40]     @ Get the color off stack
        ldr     r8,[r13,#44]     @ Get the screen base address

@ calculate pixel address

        mov     r3,#480
        mul     r7,r3,r6
        add     r7,r7,r5,lsl #1
        add     r3,r7,r8

        mov     r5,#480
5:

@ Plot pixel [r3] with color r2
        strh    r2,[r3],r5
        subs    r4,r4,#1
        bne     5b

        ldmfd   r13!,{r2-r8,r14}
        add     sp,sp,#8
        bx      r14

